/*scrivere un programma che legga il file 

dati.hh costituito da una sequenza di parole a 16 bit
senza segno

e che scriva un file compattato nel seguente modo:

- le parole che hanno un contenuto inferiore a 256 
  devono occupare un solo byte.

- Quindi si scorra il file di partenza e si scriva nel
  nuovo file:
   - 1 parola da 16 bit col numero di parole n che seguono
     con la seguente aggiunta:
     bit 15 a 1 se seguono n byte (2 per ogni parola:  se il
                                   numero n e' dispari vuol
                                   dire che il byte meno signi
                                   ficativo dell'ultima parola
                                   non ha significato)
     bit 15 a 0 se seguono n parole da 16 bit

   - le n/2 parole da 16 bit [(n+1)/2 se n e' dispari] contenenti
     gli n byte
     oppure le n parole da 16 bit

   - si cambia tipo (da byte a parole a 16 bit o viceversa) ogni 
     volta che nella sequenza si passa da un contenuto > 255 a uno
     inferiore o viceversa. Questo significa che se la sequenza e'
     128, 15, 235, 354, 456, 562, 566, 210, 18, 19, 21, 25, 36,512 
     cioe' in esadecimale
     0x0080, 0x000f, 0x00eb, 0x0162, 0x01c8, 0x0232, 0x0236, 0x00d2,
     0x0012, 0x0013, 0x0016, 0x0019, 0x0024, 0x0200......
     nel nuovo file si avra' la sequenza:
     0x8003, 0x800f, 0xeb00, 0x0004, 0x0162, 0x01c8, 0x0232, 0x0236,
     0x8006, 0xd212, 0x1316, 0x1924.........*/

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>

main()
{
int i;
 int j,k;
 unsigned short contr1,contr; /* per parole inferiori a 256*/
unsigned short parola;
unsigned short dato1[1000]; /*variabile per parole inferiori a 256*/
unsigned short duedato1[1000];
short int contr2; /*controllo per parole superiori a 256*/
unsigned short dato2[1000]; /*variabile per parole superiori a 256*/
int f;
 int fn,l;

/*Controllo che le procedure di lettura e scrittura non abbiano problemi*/

if((fn=open("compatto.hh",O_WRONLY|O_CREAT))==-1)
{
 perror("compatto.hh");
 return;
}

if((f=open("dati.hh",O_RDONLY))==-1)
{
 perror("dati.hh");
 return;
}

else
  { printf("entro nel loop\n");
    while(read(f,&parola,2))
      { printf("parola= %x\n",parola);
      contr1=0;
      contr2=0;
      j,k=0;

    if(parola<256)
    { printf("<parola= %x\n",parola);
      while(parola<256)
     {
      contr1++;
      dato1[j]=parola;
          j++;
      if(!read(f,&parola,2))return;
     }
      l=0;
     for(j=0;j<contr1;j+=2) 
     {
      duedato1[l++]= (dato1[j]<<8)+dato1[j+1];
     }
     contr =contr1|0x8000;
     write(fn,&contr,2);
     printf("contr1= %x\n",contr1);
     for(j=0;j<(contr1/2);j++)
       {printf("%x\n",duedato1[j]);
	 write(fn,&duedato1[j],2);}
     lseek(f,-2,SEEK_CUR);
    }
    else
    {
     printf(">parola= %x\n",parola);
     while(parola>=256)
        {
          contr2++;
          dato2[k]=parola;
          k++;
          if(!read(f,&parola,2)) return;
        } 
      
      write(fn,&contr2,2);
      printf("contr2= %x\n",contr2);
      for(j=0;j<contr2;j++)
	{printf("%x\n",dato2[j]);
	  write(fn,&dato2[j],2);}
      lseek(f,-2,SEEK_CUR);
    }
   }
  
close(f);
close(fn);
  }
}
